﻿using AsmodeeDigital.PlayReal.Plugin.Domain;
using AsmodeeDigital.PlayReal.Plugin.Domain.GameState;
using AsmodeeDigital.PlayReal.Plugin.Domain.Message;
using ProtoBuf;

namespace AsmodeeDigital.PlayReal.Samples.Domain.Message
{
    /// <summary>
    /// Multicast message that contains intermediate game state and message type
    /// </summary>
    [ProtoContract]
    public class Message : IMessage
    {
        /// <summary>
        /// Intermediate game state
        /// </summary>
        [ProtoMember(1)]
        public GameStateBase GameState;

        /// <summary>
        /// Message type
        /// </summary>
        [ProtoMember(2)]
        public MessageType MessageType;

        public Message()
        { }

        public Message(GameStateBase gameState, MessageType messageType)
        {
            GameState = gameState;
            MessageType = messageType;
        }
    }
}
